

#import pyjd # this is dummy in pyjs.

from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.Button import Button
from pyjamas.ui.HTML import HTML
from pyjamas.ui.Label import Label
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.TextBox import TextBox
from pyjamas import Window

from pyjamas.ui.Image import Image
from pyjamas.ui.ScrollPanel import ScrollPanel
from pyjamas.ui.DockPanel import DockPanel
from pyjamas.ui.MenuBar import MenuBar, MenuItem
from pyjamas.ui.FlexTable import FlexTable
from pyjamas.ui.Tree import Tree, TreeItem
from pyjamas.ui.PopupPanel import PopupPanel
from pyjamas.HTTPRequest import HTTPRequest
from pyjamas.JSONParser import JSONParser
from pyjamas.ui.FocusPanel import FocusPanel
from pyjamas.ui.Label import Label
from pyjamas.ui.FlowPanel import FlowPanel
from pyjamas.ui.Hyperlink import Hyperlink
import pygwt


def create_throbber(message=''):
    p = HorizontalPanel()
    im = Image('ajax-loader.gif')
    p.add(im)
    l = Label(message)
    l.setStyleName('throbber-message')
    p.add(l)
    return p

class SlideLoader:

    def __init__(self, panel):
        self.panel = panel

    def onCompletion(self, text):
        json = JSONParser().decode(text)
        self.panel.tree.clear()
        for i in json[u'ids']:
            item = Hyperlink(i)
            item.setStyleName('object-id-result')
            #item.setUserObject(i)
            item.addClickListener(self.panel.onTreeItemSelected)
            self.panel.tree.add(item)

    def onError(self, text, code):
        Window.alert(text + code)

    def onTimeout(self, text):
        Window.alert(text)


class TagLoader(object):

    def __init__(self, panel, path, row_num):
        self.panel = panel
        self.path = path
        self.row_num = row_num

    def onCompletion(self, text):
        json = JSONParser().decode(text)
        l = Label(json[u'value'])
        l.setStyleName('tag-value')
        self.panel.tags_panel.setWidget(self.row_num, 1, l)

    def onError(self, text, code):
        Window.alert(text + code)


class ObjectLoader(object):

    def __init__(self, panel, message):
        self.panel = panel
        self.panel.tags_panel.setWidget(0, 0, create_throbber(message))

    def onCompletion(self, text):
        json = JSONParser().decode(text)
        self.panel.tags_panel.clear()
        for i, path in enumerate(json[u'tagPaths']):
            l = Label(path)
            l.setStyleName(u'tag-name')
            url = '/proxy/objects/' + self.panel.object_id + '/' + path + '?format=json'
            self.panel.tags_panel.setWidget(i, 0, l)
            self.panel.tags_panel.setWidget(i, 1, create_throbber(url))
            req = HTTPRequest()
            req.asyncGet(url, TagLoader(self.panel, path, i))


class MenuCommand(object):

    def __init__(self, handler):
        self.handler = handler
    
    def execute(self):
        print 'handling'
        self.handler()

class ObjectPopup(PopupPanel):

    def __init__(self, object_id):
        PopupPanel.__init__(self, autoHide=True)
        self.object_id = object_id

        vp = VerticalPanel()
        self.add(vp)


        c = Label(object_id)
        c.setStyleName('object-id')
        vp.add(c)
        self.setStyleName("showcase-popup")
        c.addClickListener(self.on_click)

        self.tags_panel = FlexTable()
        vp.add(self.tags_panel)

        formatter = self.tags_panel.getFlexCellFormatter()
        formatter.setWidth(0, 0, "200px")
        formatter.setWidth(0, 1, "400px")

        req = HTTPRequest()
        url = "/proxy/objects/" + object_id + "?showAbout=true"
        req.asyncGet(url, ObjectLoader(self, url))



class MainWindow(DockPanel):

    def __init__(self):
        DockPanel.__init__(self)

        self.menubar = MenuBar()

        self.search_bar = HorizontalPanel()
        self.add(self.search_bar, DockPanel.NORTH)


        self.scroll = ScrollPanel()
        self.add(self.scroll, DockPanel.CENTER)

        self.tree = FlowPanel()
        self.scroll.add(self.tree)
        self.scroll.setSize('100%', '400px')
        #self.tree.addTreeListener(self)

     
        l = Label('Query:')
        l.setWidth('100px');
        self.search_bar.add(l)

        self.query_input = TextBox()
        self.query_input.setWidth('400px')
        self.search_bar.add(self.query_input)

        self.b = Button("Perform Query", self.greet, StyleName='teststyle')
        self.b.setWidth('100px')
        self.search_bar.add(self.b)

    def greet(self, fred):
        print "greet button"
        req = HTTPRequest()
        #xmlHttp = req.doCreateXmlHTTPRequest()
        url = "/proxy/objects?query=" + self.query_input.getText()
        req.asyncGet(url, SlideLoader(self))
        #xmlHttp.open("GET", url, true, None, None)
        #xmlHttp.setRequestHeader("Content-Type", "text/plain charset=utf-8")
        #xmlHttp.send('')

    def onTreeItemSelected(self, item):
        value = item.getText()
        popup_left = item.getAbsoluteLeft() + (item.getOffsetWidth() /  2)
        popup_top = item.getAbsoluteTop()

        popup = ObjectPopup(item.getText())
        popup.setPopupPosition(popup_left, popup_top)
        popup.show()

    def onTreeItemStateChanged(self, item):
        pass # We ignore this.

if __name__ == '__main__':
    #pyjd.setup("public/Hello.html?fred=foo#me")
    main = MainWindow()
    RootPanel().add(main)
    #pyjd.run()
