# -*- coding: utf-8 -*-

from os.path import dirname

from glashammer.application import make_app
from glashammer.utils import run_very_simple, sibpath

TEMPLATES_DIRECTORY = sibpath(__file__, 'templates')
SHARED_DIRECTORY = sibpath(__file__, 'shared')

from proxy import do_proxy

# Main application setup
def setup(app):
    app.add_template_searchpath(TEMPLATES_DIRECTORY)
    app.add_shared('main', SHARED_DIRECTORY)
    app.add_url('/proxy/<path:path>', 'proxy', do_proxy)

def create_app():
    return make_app(setup)

def main():
    run_very_simple(create_app())

if __name__ == '__main__':
    main()

